#include <stdio.h>
#include <stdlib.h>

int main(int argc, char *argv[])
{
  FILE *f = fopen("codetable.csv","rt");
  FILE *out = fopen("..\\src\\levcodes.h","wt");
  FILE *out2 = fopen("..\\tools\\levcodearray.h","wt");
  short a,i,j;
  char line[255];
  char hex[15];
  char name[100];
  if(!f)
  {
    fprintf(stderr,"Couldn't open codetable.csv for reading\n");
    system("PAUSE");
    return 1;
  }
  if(!out)
  {
    fprintf(stderr,"Couldn't open levcodes.h for writing\n");
    system("PAUSE");
    if(f) fclose(f);
    return 1;
  }
  if(!out2)
  {
    fprintf(stderr,"Couldn't open levcodearray.h for writing\n");
    system("PAUSE");
    if(f) fclose(f);
    if(out) fclose(out);
    return 1;
  }
  fprintf(out,"//Level Map Codes\n//These are NEGATIVE!\n\n");
  fprintf(out2,"char levcodearray[]={\n");
  for(a=0;a<255;a++)
  {
    if(fgets(line,255,f)==NULL) break;
    i = 0;
    while(line[i] != ',')
    {
      hex[i] = line[i];
      i++;
    }
    hex[i] = 0;
    i++;
    j=0;
    while(line[i] != ',')
    {
      name[j] = line[i];
      i++;j++;
    }
    name[j] = 0;
    if(name[0])
    {
      fprintf(out,"#define %s ((char)-%s)\n",name,hex);
      fprintf(out2,"%s,",hex);
    }
  }
  fprintf(out2,"};\n\n");
  fclose(f);
  fclose(out);
  return 0;
}
