#include <stdio.h>

void DisplayUsage(void)
{
 printf("
 Gray2bw Tool by Malcolm Smith
 For the FAT Engine SDK
 Converts a grayscale BIN file to
 black and white.

 Usage:
 Gray2bw [infile] [outfile] [size_in_bytes]
 infile  =  Input BIN file
 outfile = Output BIN file
 size_in_bytes = Size of data in bytes.
 (Take the X size * Y size, and divide by 8).
 ");
}

int main(int argc, char *argv[])
{
FILE *in, *out;
short a;
short bytesize = atoi(argv[3]);
char bytecur;
  if(argc!=4)
  {
  DisplayUsage();
  return 0;
  }
  in = fopen(argv[1],"rb");
  if(!in) {
  printf("\nCan't open input file.\n");
  DisplayUsage();return 0;}

  
out=fopen(argv[2],"wb");
  if(!out) {
  printf("\nCan't open output file.\n");
  DisplayUsage();return 0;}
for(a=0;a<bytesize;a++)
{
   fread(&bytecur,1,sizeof(char),in);
   fwrite(&bytecur,sizeof(char),1,out);
}

  fclose(in);
  fclose(out);
  return 0;
}

